diff --git a/Scanner.pas b/Scanner.pas
index 3496219..0aa85f0 100644
--- a/Scanner.pas
+++ b/Scanner.pas
@@ -595,6 +595,7 @@ if list or (numErr <> 0) then begin
         112: msg := @'segment buffer overflow';
         113: msg := @'all parameters must have a name';
         114: msg := @'a function call was made to a non-function';
+        119: msg := @'invalid digit for binary constant';
          otherwise: Error(57);
          end; {case}
        writeln(msg^);
@@ -2847,6 +2848,7 @@ label 1;
 var
    c2: char;                            {next character to process}
    i: integer;                          {loop index}
+   isBin: boolean;                      {is the value a binary number?}
    isHex: boolean;                      {is the value a hex number?}
    isLong: boolean;                     {is the value a long number?}
    isReal: boolean;                     {is the value a real number?}
@@ -2905,6 +2907,7 @@ var
 
 
 begin {DoNumber}
+isBin := false;                         {assume it's not binary}
 isHex := false;                         {assume it's not hex}
 isReal := false;                        {assume it's an integer}
 isLong := false;                        {assume a short integer}
@@ -2922,13 +2925,15 @@ if c2 = '.' then begin                  {handle the case of no leading digits}
    end {if}
 else begin
    GetDigits;                           {read the leading digit stream}
-   if c2 in ['x','X'] then              {detect hex numbers}
+   if c2 in ['x','X', 'b', 'B'] then              {detect hex numbers}
       if stringIndex = 1 then
          if numString[1] = '0' then begin
             stringIndex := 2;
-            numString[2] := 'X';
+            c2 := chr(ord(c2) & $5f);
+            numString[2] := c2;
+            if c2 = 'X' then isHex := true;
+            if c2 = 'B' then isBin := true;
             NextChar;
-            isHex := true;
             GetDigits;
             goto 1;
             end; {if}
@@ -3047,6 +3052,22 @@ else begin                            {hex & octal}
             end; {else}
          end; {while}
       end {if}
+   else if isBin then begin
+      i := 3;
+      while i <= length(numString) do begin
+         if token.lval & $80000000 <> 0 then begin
+            i := maxint;
+            if flagOverflows then
+               Error(6);
+            end {if}
+         else begin
+            if not (numString[i] in ['0','1']) then
+               Error(119);
+            token.lval := (token.lval << 1) | (ord(numString[i]) & $0001);
+            i := i+1;
+            end; {else}
+         end; {while}
+      end {if}
    else begin
       i := 1;
       while i <= length(numString) do begin
